"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.DEFAULT_LONG_PRESS_DELAY = void 0;
var _react = _interopRequireWildcard(require("react"));
var React = _react;
var _reactNative = require("react-native");
var _uikitUtils = require("@sendbird/uikit-utils");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
const DEFAULT_LONG_PRESS_DELAY = exports.DEFAULT_LONG_PRESS_DELAY = 350;
const PressBox = props => {
  if (props.activeOpacity && props.activeOpacity < 1) return /*#__PURE__*/React.createElement(PressBoxWithTouchableOpacity, props);
  return /*#__PURE__*/React.createElement(PressBoxWithPressable, props);
};
const PressBoxWithPressable = ({
  children,
  ...props
}) => {
  return /*#__PURE__*/React.createElement(_reactNative.Pressable, _extends({
    disabled: !props.onPress && !props.onLongPress,
    delayLongPress: DEFAULT_LONG_PRESS_DELAY
  }, props), state => (0, _uikitUtils.isFunction)(children) ? children(state) : children);
};
const PressBoxWithTouchableOpacity = ({
  children,
  style,
  ...props
}) => {
  const [pressed, setPressed] = (0, _react.useState)(false);
  const state = {
    pressed
  };
  return /*#__PURE__*/React.createElement(_reactNative.TouchableOpacity, _extends({
    disabled: !props.onPress && !props.onLongPress,
    delayLongPress: DEFAULT_LONG_PRESS_DELAY,
    style: (0, _uikitUtils.isFunction)(style) ? style(state) : style,
    onPressIn: () => setPressed(true),
    onPressOut: () => setPressed(false)
  }, props), (0, _uikitUtils.isFunction)(children) ? children(state) : children);
};
var _default = exports.default = PressBox;
//# sourceMappingURL=index.js.map