"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.DEFAULT_SCALE_FACTOR = void 0;
var _reactNative = require("react-native");
const {
  width,
  height
} = _reactNative.Dimensions.get('window');
const DESIGNED_DEVICE_WIDTH = 360;
const createScaleFactor = (deviceWidth = DESIGNED_DEVICE_WIDTH) => {
  const ratio = Math.min(width, height) / deviceWidth;
  const rangedRatio = Math.min(Math.max(0.85, ratio), 1.25);
  return dp => _reactNative.PixelRatio.roundToNearestPixel(dp * rangedRatio);
};
let DEFAULT_SCALE_FACTOR = exports.DEFAULT_SCALE_FACTOR = createScaleFactor();
var _default = exports.default = Object.assign(createScaleFactor, {
  updateScaleFactor: scaleFactor => {
    exports.DEFAULT_SCALE_FACTOR = DEFAULT_SCALE_FACTOR = scaleFactor;
  }
});
//# sourceMappingURL=createScaleFactor.js.map