"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _Box = _interopRequireDefault(require("../../components/Box"));
var _createStyleSheet = _interopRequireDefault(require("../../styles/createStyleSheet"));
var _useUIKitTheme = _interopRequireDefault(require("../../theme/useUIKitTheme"));
var _Avatar = _interopRequireDefault(require("../Avatar"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const TypingIndicatorBubble = ({
  typingUsers,
  containerStyle,
  maxAvatar
}) => {
  const {
    select,
    palette,
    colors
  } = (0, _useUIKitTheme.default)();
  if (typingUsers.length === 0) return null;
  return /*#__PURE__*/_react.default.createElement(_Box.default, {
    flexDirection: 'row',
    justifyContent: 'flex-start',
    alignItems: 'center',
    style: containerStyle
  }, /*#__PURE__*/_react.default.createElement(_Avatar.default.Stack, {
    size: 26,
    maxAvatar: maxAvatar,
    styles: {
      remainsTextColor: colors.onBackground02,
      remainsBackgroundColor: select({
        light: palette.background100,
        dark: palette.background400
      })
    },
    containerStyle: {
      marginEnd: 12
    }
  }, typingUsers.map((user, index) => /*#__PURE__*/_react.default.createElement(_Avatar.default, {
    key: index,
    uri: user.profileUrl
  }))), /*#__PURE__*/_react.default.createElement(TypingDots, {
    dotColor: select({
      light: palette.background100,
      dark: palette.background400
    }),
    backgroundColor: colors.onBackground02
  }));
};
const TypingDots = ({
  dotColor,
  backgroundColor
}) => {
  const animation = (0, _react.useRef)(new _reactNative.Animated.Value(0)).current;
  const dots = matrix.map(([timeline, scale, opacity]) => [animation.interpolate({
    inputRange: timeline,
    outputRange: scale,
    extrapolate: 'clamp'
  }), animation.interpolate({
    inputRange: timeline,
    outputRange: opacity,
    extrapolate: 'clamp'
  })]);
  (0, _react.useEffect)(() => {
    const animated = _reactNative.Animated.loop(_reactNative.Animated.timing(animation, {
      toValue: 1.4,
      duration: 1400,
      easing: _reactNative.Easing.linear,
      useNativeDriver: true
    }));
    animated.start();
    return () => animated.reset();
  }, []);
  return /*#__PURE__*/_react.default.createElement(_Box.default, {
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'center',
    borderRadius: 16,
    paddingHorizontal: 12,
    height: 34,
    backgroundColor: dotColor
  }, dots.map(([scale, opacity], index) => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
      key: index,
      style: [styles.dot, {
        marginEnd: index === dots.length - 1 ? 0 : 6,
        opacity: opacity,
        transform: [{
          scale: scale
        }],
        backgroundColor: backgroundColor
      }]
    });
  }));
};
const matrix = [[[0.4, 0.7, 1.0], [1.0, 1.2, 1.0], [0.12, 0.38, 0.12]], [[0.6, 0.9, 1.2], [1.0, 1.2, 1.0], [0.12, 0.38, 0.12]], [[0.8, 1.1, 1.4], [1.0, 1.2, 1.0], [0.12, 0.38, 0.12]]];
const styles = (0, _createStyleSheet.default)({
  dot: {
    width: 8,
    height: 8,
    borderRadius: 4
  }
});
var _default = exports.default = TypingIndicatorBubble;
//# sourceMappingURL=index.js.map