import React from 'react';
import { ViewProps, ViewStyle } from 'react-native';
import type { UIKitColors, UIKitPalette } from '../../types';
type DeprecatedBoxProps = {
    /** @deprecated Please use `paddingStart` instead **/
    paddingLeft?: ViewStyle['paddingLeft'];
    /** @deprecated Please use `paddingEnd` instead **/
    paddingRight?: ViewStyle['paddingRight'];
    /** @deprecated Please use `marginStart` instead **/
    marginLeft?: ViewStyle['marginLeft'];
    /** @deprecated Please use `marginEnd` instead **/
    marginRight?: ViewStyle['marginRight'];
};
type BaseBoxProps = Pick<ViewStyle, 'flex' | 'flexShrink' | 'flexGrow' | 'flexDirection' | 'alignItems' | 'justifyContent' | 'borderRadius' | 'borderWidth' | 'borderColor' | 'borderBottomColor' | 'borderBottomWidth' | 'margin' | 'marginHorizontal' | 'marginVertical' | 'marginStart' | 'marginEnd' | 'marginTop' | 'marginBottom' | 'padding' | 'paddingHorizontal' | 'paddingVertical' | 'paddingStart' | 'paddingEnd' | 'paddingTop' | 'paddingBottom' | 'overflow' | 'width' | 'height'> & {
    backgroundColor?: string | ((theme: {
        colors: UIKitColors;
        palette: UIKitPalette;
    }) => string);
};
type BoxProps = BaseBoxProps & DeprecatedBoxProps & ViewProps;
declare const Box: ({ style, children, ...props }: BoxProps) => React.JSX.Element;
export default Box;
